@echo off
REM Dienste Konfiguration fr Windows Vista
REM (c) F.Ullrich - WinFAQ.DE
REM Version 1.0 / 20.02.2008
REM Homepage: http://www.winfaq.de

SET ProgVersion=1.0
SET ProgDatum=20.02.2008
SET ProgName=vista_service_config.cmd

REM ******************************************************************
REM Hat sich das Tool selber aufgerufen...
if #%1#==#servicecheck# goto servicecheck
if #%1#==#servicesave# goto servicesave
REM ******************************************************************

REM ******************************************************************
REM Prfen der Betriebssystemversion und ob entsprechende Rechte vorhanden sind
ver | find /i "Windows [Version 6.0.">nul
if not errorlevel 1 goto CheckAdmin
cls
echo Dienste Konfiguration fr Windows Vista
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Info: Tool ist nur fr Windows Vista 6.0.x geeigent...
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end
:CheckAdmin
reg add HKLM\Software /v AdminCheck /t REG_SZ /d OK>NUL
if errorlevel 1 goto Show_CheckAdmin
reg delete HKLM\Software /v AdminCheck /f>NUL
REM ******************************************************************

echo "%CMDCMDLINE%"|"find" /i "/C">NUL
if errorlevel 1 goto cmdStart
for /f "eol= tokens=2*" %%i in (%CMDCMDLINE%) do Set ProgPfad=%%~dj%%~pj
Set ProgName=%ProgPfad%%ProgName%
cd /d %ProgPfad%

:cmdStart
if not exist "%ProgName%" goto Show_ProgName

if not #%1#==## goto setfileconfig

cls
echo Dienste Konfiguration fr Windows Vista
echo Version: %ProgVersion% - %ProgDatum%
echo.

set SaveConfig=NO
set Datum=%date::=%
SET BackupFile=ServiceBackup_%Datum%.txt
if not exist "%ProgPfad%%BackupFile%" goto :BFilenotExist
echo INFO: Sicherungsdatei %BackupFile% ist schon vorhanden...
echo       Wenn Sie eine Funktion ausfhren, wird die alte Sicherungsdatei
echo       berschrieben.
echo.
:BFilenotExist

REM ******************************************************************
:Menu
echo.
echo                             Men
echo.
echo  Bitte whlen sie einen Punkt aus:
echo.
echo  (1) Standardeinstellungen Windows Home Basic
echo  (2) Standardeinstellungen Windows Home Premium
echo  (3) Standardeinstellungen Windows Business
echo  (4) Standardeinstellungen Windows Ultimate
echo.
echo  (5) Empfehlung Normal
echo  (6) Empfehlung Minimal (Achtung: wenig Dienste aktiv)
echo.
echo  (S) Konfiguration sichern
echo.
set /P key= Bitte whlen Sie: [1],[2],[3],[4],[5],[6] oder [S], [Q]uit? 
if /I #%key%#==#Q# goto :End
if /I #%key%#==#S# (
		Set configfile=Service_VistaUltimate.txt
		SET BackupFile=ServiceBackup_%Computername%_%Datum%.txt
		Set SaveConfig=YES
		goto :service
		)
if /I #%key%#==#1# (
		Set configfile=Service_VistaHomeBasic.txt
		goto :service
		)
if /I #%key%#==#2# (
		Set configfile=Service_VistaHomePremium.txt
		goto :service
		)
if /I #%key%#==#3# (
		Set configfile=Service_VistaBusiness.txt
		goto :service
		)
if /I #%key%#==#4# (
		Set configfile=Service_VistaUltimate.txt
		goto :service
		)
if /I #%key%#==#5# (
		Set configfile=Service_Vista_NormalConfig.txt
		goto :service
		)
if /I #%key%#==#6# (
		Set configfile=Service_Vista_MinimalConfig.txt
		goto :service
		)
echo Es wurde eine ungltige Taste gedrckt...
goto end
REM ******************************************************************

REM ******************************************************************
REM Hier wird die Konfigurationsdatei eingelesen
:service
if NOT #%SaveConfig%#==#YES# goto startservice
if NOT exist "%ProgPfad%%Backupfile%" goto startservice
echo.
echo Die Sicherungsdatei %Backupfile% ist schon vorhanden!
echo Soll die Datei neu erstellt werden?
set /P key= [J]a oder [Q]uit?
if /I #%key%#==#Q# goto :End
:startservice
if not exist "%ProgPfad%%configfile%" goto configfilenotfound
echo Backupfile fr: %Computername%>"%ProgPfad%%BackupFile%"
for /f "eol=; skip=1 tokens=1,2,3*" %%i in (%configfile%) do call "%ProgName%" servicecheck %%i %%j
if #%SaveConfig%#==#YES# Goto Show_SaveConfig
goto Show_SetConfig
goto end
REM ******************************************************************

:setfileconfig
cls
echo Dienste Konfiguration fr Windows Vista
echo.
echo Setze die Einstellungen ber %1
echo.
if not exist "%1" goto filenotfond
set configfile=%1
set Datum=%date::=%
SET BackupFile=ServiceBackup_%Datum%.txt
If /I #%BackupFile%#==#%1# Set BackupFile=ServiceBackup02_%Datum%.txt
goto service
goto end

REM ******************************************************************
REM Auslesen der aktuellen Einstellungen und speichern der Konfiguration
:servicecheck
echo Bearbeite Service: %2
for /f "eol=: skip=4 tokens=1,2,3*" %%i in ('sc qc %2') do call "%ProgName%" servicesave %2 %3 %%i %%k "%%l" 
goto end

:servicesave
if not #%4#==#START_TYPE# Goto end
if /I #%5#==#0# Set StartType=BOOT
if /I #%5#==#1# Set StartType=SYSTEM
if /I #%5#==#2# Set StartType=AUTO
if /I %6=="AUTO_START  (DELAYED)" Set StartType=DELAYED-AUTO
if /I #%5#==#3# Set StartType=DEMAND
if /I #%5#==#4# Set StartType=DISABLED
echo %2;%StartType%>>"%ProgPfad%%BackupFile%"
if #%SaveConfig%#==#YES# Goto end
if /I #%StartType%#==#%3# echo                    gleiche Einstellung...
if /I #%StartType%#==#%3# goto end
echo               von: %StartType% auf %3
sc config %2 start= %3>nul
if errorlevel 1 goto Show_ErrorSC
goto end
REM ******************************************************************

:configfilenotfound
echo.
echo Fehler:
echo -------
echo.
echo Die angegebene Datei %configfile% wurde nicht gefunden.
echo Haben Sie das Programm aus dem Installationsverzeichnis gestartet?
echo.
goto end

:filenotfond
echo.
echo Fehler:
echo -------
echo.
echo Die angegebene Datei %1 wurde nicht gefunden. Bitte geben Sie einen 
echo Dateinamen an, der auch vorhanden ist. 
echo Die Einstellungen werden anhand der Datei vorgenommen.
echo.
goto end

:Show_SaveConfig
echo.
echo Die aktulle Konfiguration wurde gesichert als
echo %BackupFile%
echo Durch den Aufruf von:
echo "service_config.cmd %BackupFile%"
echo knnen Sie diese Einstellungen setzen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_SetConfig
echo.
echo Die alte Konfiguration wurde gesichert als:
echo %BackupFile%
echo Durch den Aufruf von:
echo "service_config.cmd %BackupFile%"
echo knnen Sie diese Einstellungen wieder hestellen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_CheckAdmin
cls
echo Dienste Konfiguration fr Windows Vista
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Damit das Tool richtig arbeitet mssen Sie es als Administrator
echo ausfhren.
echo Klicken Sie die Datei mit der rechten Maustaste an und w'hlen
echo Sie aus dem Kontextmen den Eintrag "Als Administrator ausfhren"
echo aus.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_ProgName
cls
echo Dienste Konfiguration fr Windows Vista
echo Version: %ProgVersion% - %ProgDatum%
echo.
echo Sie haben den Programmnamen gendert.
echo.
echo Damit das Programm luft mssen Sie auch die Variable:
echo ProgName anpassen.
echo.
echo Weiter mit einer Taste...
pause>NUL
goto end

:Show_ErrorSC
echo.
echo Bei setzten der Startart mit SC ist ein Fehler aufgetreten
echo.
echo Beenden mit einer Taste...
pause>NUL
exit

:End
